<div align="center">
    <img src="encompass-logo-and-text.png?raw=true" alt="Encompass" width="400">
</div>

A powerful engine-agnostic Hyper ECS framework for game development.

Object-oriented game code is messy and unmaintainable.
Encompass lets you write clean, de-coupled code so you can spend more time refining your design and less time fixing bugs.

Fully supports the [TypescriptToLua](https://github.com/TypeScriptToLua/TypeScriptToLua) project. Write your games in TypeScript and compile to Lua! We love [LÖVE](https://love2d.org)!

## Documentation

API:
https://encompass-ts.readthedocs.io

## Starter Templates

LOVE: https://gitlab.com/encompass-ecs/encompass-love2d-starter

## Example Projects

Some example projects are complete or in active development.

### JS
* Vapor FM frontend: https://gitlab.com/encompass-ecs/encompass-vapor-fm

### Lua
* Game of Life: https://gitlab.com/encompass-ecs/encompass-game-of-life
* Hyperspace: https://gitlab.com/ehemsley/hyperspace-ts