--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
-- Lua Library inline imports
function __TS__Index(classProto)
    return function(tbl, key)
        local proto = classProto
        while true do
            local val = rawget(proto, key)
            if val ~= nil then
                return val
            end
            local getters = rawget(proto, "____getters")
            if getters then
                local getter = getters[key]
                if getter then
                    return getter(tbl)
                end
            end
            local base = rawget(rawget(proto, "constructor"), "____super")
            if not base then
                break
            end
            proto = rawget(base, "prototype")
        end
    end
end

local ____symbolMetatable = {__tostring = function(self)
    if self.description == nil then
        return "Symbol()"
    else
        return "Symbol(" .. tostring(self.description) .. ")"
    end
end}
function __TS__Symbol(description)
    return setmetatable({description = description}, ____symbolMetatable)
end
Symbol = {
    iterator = __TS__Symbol("Symbol.iterator"),
    hasInstance = __TS__Symbol("Symbol.hasInstance"),
}

function __TS__InstanceOf(obj, classTbl)
    if (type(classTbl) == "table" and "object" or type(classTbl)) ~= "object" then
        error("Right-hand side of \'instanceof\' is not an object")
    end
    if classTbl[Symbol.hasInstance] ~= nil then
        return not not classTbl[Symbol.hasInstance](classTbl, obj)
    end
    if obj ~= nil then
        local luaClass = obj.constructor
        while luaClass ~= nil do
            if luaClass == classTbl then
                return true
            end
            luaClass = luaClass.____super
        end
    end
    return false
end

function __TS__Iterator(iterable)
    if iterable[Symbol.iterator] then
        local iterator = iterable[Symbol.iterator](iterable)
        return function()
            local result = iterator:next()
            if not result.done then
                return result.value
            else
                return nil
            end
        end
    else
        local i = 0
        return function()
            i = i + 1
            return iterable[i]
        end
    end
end

Map = {}
Map.name = "Map"
Map.__index = Map
Map.prototype = {}
Map.prototype.__index = Map.prototype
Map.prototype.constructor = Map
function Map.new(...)
    local self = setmetatable({}, Map.prototype)
    self:____constructor(...)
    return self
end
function Map.prototype.____constructor(self, other)
    self.items = {}
    self.size = 0
    if other then
        local iterable = other
        if iterable[Symbol.iterator] then
            local iterator = iterable[Symbol.iterator](iterable)
            while true do
                local result = iterator:next()
                if result.done then
                    break
                end
                local value = result.value
                self:set(value[0 + 1], value[1 + 1])
            end
        else
            local arr = other
            self.size = #arr
            for ____TS_index = 1, #arr do
                local kvp = arr[____TS_index]
                self.items[kvp[0 + 1]] = kvp[1 + 1]
            end
        end
    end
end
function Map.prototype.clear(self)
    self.items = {}
    self.size = 0
    return
end
function Map.prototype.delete(self, key)
    local contains = self:has(key)
    if contains then
        self.size = self.size - 1
    end
    self.items[key] = nil
    return contains
end
Map.prototype[Symbol.iterator] = function(self)
    return self:entries()
end
function Map.prototype.entries(self)
    local items = self.items
    local key
    local value
    return {
        [Symbol.iterator] = function(self)
            return self
        end,
        next = function(self)
            key, value = next(items, key)
            return {
                done = not key,
                value = {
                    key,
                    value,
                },
            }
        end,
    }
end
function Map.prototype.forEach(self, callback)
    for key in pairs(self.items) do
        callback(_G, self.items[key], key, self)
    end
    return
end
function Map.prototype.get(self, key)
    return self.items[key]
end
function Map.prototype.has(self, key)
    return self.items[key] ~= nil
end
function Map.prototype.keys(self)
    local items = self.items
    local key
    return {
        [Symbol.iterator] = function(self)
            return self
        end,
        next = function(self)
            key = next(items, key)
            return {
                done = not key,
                value = key,
            }
        end,
    }
end
function Map.prototype.set(self, key, value)
    if not self:has(key) then
        self.size = self.size + 1
    end
    self.items[key] = value
    return self
end
function Map.prototype.values(self)
    local items = self.items
    local key
    local value
    return {
        [Symbol.iterator] = function(self)
            return self
        end,
        next = function(self)
            key, value = next(items, key)
            return {
                done = not key,
                value = value,
            }
        end,
    }
end

local ____exports = {}
____exports.GCOptimizedList = {}
local GCOptimizedList = ____exports.GCOptimizedList
GCOptimizedList.name = "GCOptimizedList"
GCOptimizedList.__index = GCOptimizedList
GCOptimizedList.prototype = {}
GCOptimizedList.prototype.____getters = {}
GCOptimizedList.prototype.__index = __TS__Index(GCOptimizedList.prototype)
GCOptimizedList.prototype.constructor = GCOptimizedList
function GCOptimizedList.new(...)
    local self = setmetatable({}, GCOptimizedList.prototype)
    self:____constructor(...)
    return self
end
function GCOptimizedList.prototype.____constructor(self, ...)
    local entries = ({...})
    self.items = Map.new()
    self.indices = Map.new()
    self._size = 0
    for ____TS_index = 1, #entries do
        local k = entries[____TS_index]
        self:add(k)
    end
end
function GCOptimizedList.prototype.____getters.size(self)
    return self._size
end
function GCOptimizedList.prototype.forEach(self, callback)
    do
        local i = 0
        while i < self.size do
            callback(nil, self:get(i))
            i = i + 1
        end
    end
end
function GCOptimizedList.prototype.entries(self)
    return self.items
end
function GCOptimizedList.prototype.values(self)
    return self.items:values()
end
function GCOptimizedList.prototype.add(self, value)
    self.items:set(self._size, value)
    self.indices:set(value, self._size)
    self._size = self._size + 1
end
function GCOptimizedList.prototype.clear(self)
    for k, v in self:entries() do
        self.items:delete(k)
        self.indices:delete(v)
    end
    self._size = 0
end
function GCOptimizedList.prototype.delete(self, index)
    if self:hasIndex(index) then
        local value = self:get(index)
        self.items:delete(index)
        self.indices:delete(value)
        local k = index
        self._size = self._size - 1
        while k < self.size do
            local one_up_value = self.items:get(k + 1)
            if one_up_value ~= nil then
                self.items:set(k, one_up_value)
                self.indices:set(one_up_value, k)
            end
            k = k + 1
        end
        self.items:delete(self.size)
        return true
    end
    return false
end
function GCOptimizedList.prototype.deleteValue(self, value)
    local index = self:indexOf(value)
    if index ~= nil then
        self:delete(index)
        return true
    end
    return false
end
function GCOptimizedList.prototype.indexOf(self, value)
    if self.indices:has(value) then
        return self.indices:get(value)
    else
        return nil
    end
end
function GCOptimizedList.prototype.get(self, index)
    return self.items:get(index)
end
function GCOptimizedList.prototype.empty(self)
    return self.size == 0
end
function GCOptimizedList.prototype.hasIndex(self, index)
    return self.items:has(index)
end
function GCOptimizedList.prototype.hasValue(self, value)
    return self.indices:has(value)
end
function GCOptimizedList.prototype.shift(self)
    if not self:empty() then
        local item = self.items:get(0)
        self:delete(0)
        return item
    else
        return nil
    end
end
function GCOptimizedList.prototype.pop(self)
    if not self:empty() then
        local item = self.items:get(self.size - 1)
        self:delete(self.size - 1)
        return item
    else
        return nil
    end
end
GCOptimizedList.Empty = ____exports.GCOptimizedList.new()
return ____exports
