--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
-- Lua Library inline imports
function __TS__Index(classProto)
    return function(tbl, key)
        local proto = classProto
        while true do
            local val = rawget(proto, key)
            if val ~= nil then
                return val
            end
            local getters = rawget(proto, "____getters")
            if getters then
                local getter = getters[key]
                if getter then
                    return getter(tbl)
                end
            end
            local base = rawget(rawget(proto, "constructor"), "____super")
            if not base then
                break
            end
            proto = rawget(base, "prototype")
        end
    end
end

local ____symbolMetatable = {__tostring = function(self)
    if self.description == nil then
        return "Symbol()"
    else
        return "Symbol(" .. tostring(self.description) .. ")"
    end
end}
function __TS__Symbol(description)
    return setmetatable({description = description}, ____symbolMetatable)
end
Symbol = {
    iterator = __TS__Symbol("Symbol.iterator"),
    hasInstance = __TS__Symbol("Symbol.hasInstance"),
}

function __TS__InstanceOf(obj, classTbl)
    if (type(classTbl) == "table" and "object" or type(classTbl)) ~= "object" then
        error("Right-hand side of \'instanceof\' is not an object")
    end
    if classTbl[Symbol.hasInstance] ~= nil then
        return not not classTbl[Symbol.hasInstance](classTbl, obj)
    end
    if obj ~= nil then
        local luaClass = obj.constructor
        while luaClass ~= nil do
            if luaClass == classTbl then
                return true
            end
            luaClass = luaClass.____super
        end
    end
    return false
end

function __TS__Iterator(iterable)
    if iterable[Symbol.iterator] then
        local iterator = iterable[Symbol.iterator](iterable)
        return function()
            local result = iterator:next()
            if not result.done then
                return result.value
            else
                return nil
            end
        end
    else
        local i = 0
        return function()
            i = i + 1
            return iterable[i]
        end
    end
end

Set = {}
Set.name = "Set"
Set.__index = Set
Set.prototype = {}
Set.prototype.__index = Set.prototype
Set.prototype.constructor = Set
function Set.new(...)
    local self = setmetatable({}, Set.prototype)
    self:____constructor(...)
    return self
end
function Set.prototype.____constructor(self, other)
    self.items = {}
    self.size = 0
    if other then
        local iterable = other
        if iterable[Symbol.iterator] then
            local iterator = iterable[Symbol.iterator](iterable)
            while true do
                local result = iterator:next()
                if result.done then
                    break
                end
                self:add(result.value)
            end
        else
            local arr = other
            self.size = #arr
            for ____TS_index = 1, #arr do
                local value = arr[____TS_index]
                self.items[value] = true
            end
        end
    end
end
function Set.prototype.add(self, value)
    if not self:has(value) then
        self.size = self.size + 1
    end
    self.items[value] = true
    return self
end
function Set.prototype.clear(self)
    self.items = {}
    self.size = 0
    return
end
function Set.prototype.delete(self, value)
    local contains = self:has(value)
    if contains then
        self.size = self.size - 1
    end
    self.items[value] = nil
    return contains
end
Set.prototype[Symbol.iterator] = function(self)
    return self:values()
end
function Set.prototype.entries(self)
    local items = self.items
    local key
    return {
        [Symbol.iterator] = function(self)
            return self
        end,
        next = function(self)
            key = next(items, key)
            return {
                done = not key,
                value = {
                    key,
                    key,
                },
            }
        end,
    }
end
function Set.prototype.forEach(self, callback)
    for key in pairs(self.items) do
        callback(_G, key, key, self)
    end
    return
end
function Set.prototype.has(self, value)
    return self.items[value] == true
end
function Set.prototype.keys(self)
    local items = self.items
    local key
    return {
        [Symbol.iterator] = function(self)
            return self
        end,
        next = function(self)
            key = next(items, key)
            return {
                done = not key,
                value = key,
            }
        end,
    }
end
function Set.prototype.values(self)
    local items = self.items
    local key
    return {
        [Symbol.iterator] = function(self)
            return self
        end,
        next = function(self)
            key = next(items, key)
            return {
                done = not key,
                value = key,
            }
        end,
    }
end

local ____exports = {}
____exports.GCOptimizedSet = {}
local GCOptimizedSet = ____exports.GCOptimizedSet
GCOptimizedSet.name = "GCOptimizedSet"
GCOptimizedSet.__index = GCOptimizedSet
GCOptimizedSet.prototype = {}
GCOptimizedSet.prototype.____getters = {}
GCOptimizedSet.prototype.__index = __TS__Index(GCOptimizedSet.prototype)
GCOptimizedSet.prototype.constructor = GCOptimizedSet
function GCOptimizedSet.new(...)
    local self = setmetatable({}, GCOptimizedSet.prototype)
    self:____constructor(...)
    return self
end
function GCOptimizedSet.prototype.____constructor(self, ...)
    local items = ({...})
    self.items = Set.new({unpack(items)})
end
function GCOptimizedSet.prototype.____getters.size(self)
    return self.items.size
end
function GCOptimizedSet.prototype.entries(self)
    return self.items
end
function GCOptimizedSet.prototype.add(self, value)
    self.items:add(value)
    return self
end
function GCOptimizedSet.prototype.clear(self)
    for k in __TS__Iterator(self.items) do
        self:delete(k)
    end
end
function GCOptimizedSet.prototype.delete(self, value)
    return self.items:delete(value)
end
function GCOptimizedSet.prototype.has(self, value)
    return self.items:has(value)
end
GCOptimizedSet.Empty = ____exports.GCOptimizedSet.new()
return ____exports
