import { Engine } from "../engine";
import { Message } from "../message";
import { Type } from "../types/generic_type";

/**
 * A Spawner is a special subtype of Engine which is intended
 * to read one single type of Message and create a new Entity
 * in response.
 */
export abstract class Spawner extends Engine {
    protected abstract readonly spawn_message_type: Type<Message>;

    public update(dt: number) {
        const messages = this.read_messages(this.spawn_message_type);
        for (const message of messages.values()) {
            this.spawn(message);
        }
    }

    protected abstract spawn(message: Message): void;
}
