import { Component } from "../../component";
import { Entity } from "../../entity";
import { Type } from "../../types/generic_type";

export class EntityChecker {
    public static check_entity(entity: Entity, component_types: Type<Component>[]) {
        let has_all_components = true;

        for (const component_type of component_types) {
            has_all_components = has_all_components && entity.has_component(component_type);
            if (!has_all_components) { return false; }
        }

        return has_all_components;
    }
}
