import { Engine } from "../engine";

export class EngineCycleError {
    private cycles: Engine[][];

    constructor(cycles: Engine[][]) {
        this.cycles = cycles;
    }

    public toString() {
        let string = "Cycle(s) found in engines:";
        for (const cycle of this.cycles) {
            string += "\n" +
            cycle.map((engine) => engine.constructor.name).join(" -> ") +
            " -> " +
            cycle[0].constructor.name;
        }
        return string;
    }
}
