import { Component } from "../component";
import { Engine } from "../engine";
import { Type } from "../types/generic_type";

export class EngineMutationConflictError {
    private duplicate_mutations: Type<Component>[];
    private component_to_engines_map: Map<Type<Component>, Engine[]>;

    constructor(
        duplicate_mutations: Type<Component>[],
        component_to_engines_map: Map<Type<Component>, Engine[]>,
    ) {
        this.duplicate_mutations = duplicate_mutations;
        this.component_to_engines_map = component_to_engines_map;
    }

    public toString() {
        let string = "Multiple engines mutate the same component:";
        for (const component_type of this.duplicate_mutations) {
            string += "\n" +
            component_type.name + " mutated by: ";
            const engines = this.component_to_engines_map.get(component_type)!;
            string += engines.map((engine) => engine.constructor.name).join(", ");
        }
        return string;
    }
}
