import { Component } from "../component";
import { Type } from "../types/generic_type";

export class IllegalComponentMutationError {
    private component_type: Type<Component>;
    private engine_name: string;

    constructor(engine_name: string, component_type: Type<Component>) {
        this.engine_name = engine_name;
        this.component_type = component_type;
    }

    public toString() {
        return this.engine_name + " tried to mutate an undeclared component of type: " + this.component_type.name;
    }
}
