import { Component } from "../component";
import { Message } from "../message";
import { Type } from "../types/generic_type";

export class SingletonReadError {
    private element_type: Type<Message> | Type<Component>;
    private engine_name: string;

    constructor(engine_name: string, type: Type<Message> | Type<Component>) {
        this.engine_name = engine_name;
        this.element_type = type;
    }

    public toString() {
        return this.engine_name + " tried to read a singleton, but multiple " + this.element_type.name + " existed";
    }
}
