import { DrawComponent } from "./draw_component";
import { IDrawable } from "./interfaces/drawable";
import { Renderer } from "./renderer";
import { EntityRenderer } from "./renderers/entity";
import { GeneralRenderer } from "./renderers/general";

export class TypeGuard {
    public static drawable_is_draw_component(drawable: IDrawable): drawable is DrawComponent {
        return (drawable as DrawComponent).type !== undefined;
    }

    public static drawable_is_general_renderer(drawable: IDrawable): drawable is GeneralRenderer {
        return (drawable as GeneralRenderer).render !== undefined;
    }

    public static renderer_is_entity_renderer(renderer: Renderer): renderer is EntityRenderer {
        return (renderer as EntityRenderer).check_and_track_entity !== undefined;
    }

    public static renderer_is_general_renderer(renderer: Renderer): renderer is GeneralRenderer {
        return (renderer as GeneralRenderer).layer !== undefined;
    }
}
